
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class BranchesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.create(
            {
                id: data.id || undefined,
        
        branch_name: data.branch_name
        ||
        null
            ,
            
        address_line1: data.address_line1
        ||
        null
            ,
            
        address_line2: data.address_line2
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        state: data.state
        ||
        null
            ,
            
        pincode: data.pincode
        ||
        null
            ,
            
        gst_registration_number: data.gst_registration_number
        ||
        null
            ,
            
        is_head_office: data.is_head_office
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await branches.setCompany( data.company || null, {
            transaction,
        });
        
        await branches.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return branches;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const branchesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                branch_name: item.branch_name
            ||
            null
            ,
            
                address_line1: item.address_line1
            ||
            null
            ,
            
                address_line2: item.address_line2
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                state: item.state
            ||
            null
            ,
            
                pincode: item.pincode
            ||
            null
            ,
            
                gst_registration_number: item.gst_registration_number
            ||
            null
            ,
            
                is_head_office: item.is_head_office
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const branches = await db.branches.bulkCreate(branchesData, { transaction });

        // For each item created, replace relation files
        

        return branches;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const branches = await db.branches.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.branch_name !== undefined) updatePayload.branch_name = data.branch_name;
        
        
        if (data.address_line1 !== undefined) updatePayload.address_line1 = data.address_line1;
        
        
        if (data.address_line2 !== undefined) updatePayload.address_line2 = data.address_line2;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.state !== undefined) updatePayload.state = data.state;
        
        
        if (data.pincode !== undefined) updatePayload.pincode = data.pincode;
        
        
        if (data.gst_registration_number !== undefined) updatePayload.gst_registration_number = data.gst_registration_number;
        
        
        if (data.is_head_office !== undefined) updatePayload.is_head_office = data.is_head_office;
        
        
        updatePayload.updatedById = currentUser.id;

        await branches.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await branches.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await branches.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return branches;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of branches) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of branches) {
                await record.destroy({transaction});
            }
        });


        return branches;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findByPk(id, options);

        await branches.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await branches.destroy({
            transaction
        });

        return branches;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findOne(
            { where },
            { transaction },
        );

        if (!branches) {
            return branches;
        }

        const output = branches.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.company_compliances_branch = await branches.getCompany_compliances_branch({
            transaction
        });
        
        
        output.tasks_branch = await branches.getTasks_branch({
            transaction
        });
        
        
        output.documents_branch = await branches.getDocuments_branch({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.compliance_rule_overrides_branch = await branches.getCompliance_rule_overrides_branch({
            transaction
        });
        
        
        
        
        
        output.company = await branches.getCompany({
            transaction
        });
        
        
        output.organizations = await branches.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              company_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.branch_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'branch_name',
                        filter.branch_name,
                    ),
                };
            }
            
            if (filter.address_line1) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'address_line1',
                        filter.address_line1,
                    ),
                };
            }
            
            if (filter.address_line2) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'address_line2',
                        filter.address_line2,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.pincode) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'pincode',
                        filter.pincode,
                    ),
                };
            }
            
            if (filter.gst_registration_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'gst_registration_number',
                        filter.gst_registration_number,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.state) {
                where = {
                    ...where,
                state: filter.state,
            };
            }
            
            if (filter.is_head_office) {
                where = {
                    ...where,
                is_head_office: filter.is_head_office,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.branches.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'branches',
                        'branch_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.branches.findAll({
            attributes: [ 'id', 'branch_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['branch_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.branch_name,
        }));
    }

    
};

